VehicleInCarrier = false
Guards = {}


carrierParkZone = BoxZone:Create(Config.Carrier.Vehicle['parking']['coords'], Config.Carrier.Vehicle['parking']["length"], Config.Carrier.Vehicle['parking']["width"], {
    name="Vehicleparking",
    heading=Config.Carrier.Vehicle['parking']["heading"],
    debugPoly=Config.Carrier.Vehicle['parking'].debugPoly,
    minZ=Config.Carrier.Vehicle['parking']["minz"],
    maxZ=Config.Carrier.Vehicle['parking']["maxz"]
})

function loadModel(model)
    while not HasModelLoaded(GetHashKey(model)) do
        RequestModel(GetHashKey(model))
        Citizen.Wait(50)
    end
end

function isNight()
    local hour = GetClockHours()
    if hour > 19 or hour < 5 then
     return true
    end
end

local function SetBlipVehicle(a)
    VehicleBlip = AddBlipForEntity(a)
    SetBlipFlashes(VehicleBlip, true)
    SetBlipSprite(VehicleBlip, 229)
    SetBlipColour(VehicleBlip, 75)
    BeginTextCommandSetBlipName("STRING")
    AddTextComponentString(Lang:t('CarHeist'))
    EndTextCommandSetBlipName(VehicleBlip)
end

function SpawnGuards()
    for _, v in pairs(Config.Peds.Guards) do
        loadModel(v.modelHash)
        Guards.k = CreatePed(0, GetHashKey(v.modelHash), v.coords, false, false)
        GiveWeaponToPed(Guards.k, Config.Peds.Guards.Weapon, 100, false, true)
        SetPedAccuracy(Guards.k, 10)
        SetPedSeeingRange(Guards.k, 100.0)
		SetPedHearingRange(Guards.k, 80.0)
		SetPedCombatAttributes(Guards.k, 46, 1)
		SetPedFleeAttributes(Guards.k, 0, 0)
		SetPedCombatRange(Guards.k,1)
        SetPedDiesWhenInjured(Guards.k, true)
        SetPedSeeingRange(Guards.k, 100.0)
        SetPedEnableWeaponBlocking(Guards.k, true)
        SetEntityOnlyDamagedByPlayer(Guards.k, true)
        SetPedRelationshipGroupHash(Guards.k, GetHashKey(Guards.k))
		SetRelationshipBetweenGroups(5,GetHashKey("PLAYER"),GetHashKey(Guards.k))
		SetRelationshipBetweenGroups(5,GetHashKey(Guards.k),GetHashKey("PLAYER"))
        TaskCombatHatedTargetsAroundPed(PlayerPedId(), 50.0, 0)
		SetPedDiesInWater(Guards.k, false)
        TaskCombatPed(Guards.k, PlayerPedId(), 0, 16)
        SetPedHasAiBlip(Guards.k, true)
    end
end

function Loot(needSuccess, type, boxid, k)
    local succeededAttempts = 0 -- changes dynamically do not edit
    local Skillbar = exports['qb-skillbar']:GetSkillbarObject()
    Skillbar.Start({
        duration = math.random(7500, 15000), -- how long the skillbar runs for
        pos = math.random(10, 15), -- how far to the right the static box is
        width = math.random(10, 20), -- how wide the static box is
    }, function()
        if succeededAttempts + 1 >= needSuccess then
            local ply = PlayerPedId()
            exports['qb-target']:RemoveZone(boxid)
            if type == 'drug' then
                QBCore.Functions.Progressbar('drugs', Lang:t('progressbar.drug_label'), Config.Box.Drugs.LootTime, false, false, {
                    disableMovement = true,
                    disableCarMovement = true,
                    disableMouse = false,
                    disableCombat = true
                    }, {
                        animDict = 'mini@repair',
                        anim = 'fixing_a_player',
                        flags = 1, 
                    }, {}, {}, function()
                        for i = math.random(2,5), 1, -1 do
                            local item = Config.Box.Drugs.Items[math.random(#Config.Box.Drugs.Items)]
                            local quantity = math.random(Config.Box.Drugs.Quantity.Min, Config.Box.Drugs.Quantity.Max)
                            TriggerServerEvent('pp-weedshoprv2:server:rewardItem', 'item', item, quantity, 'add')
                            ClearPedTasks(ply)
                        end
                        TriggerServerEvent('pp-weedshoprv2:server:event', 'drug', k)
                        -- BoxesLooted()
                    end, function()
                        ClearPedTasks(ply)
                end)
            elseif type == 'ammo' then
                QBCore.Functions.Progressbar('ammo', Lang:t('progressbar.ammo_label'), Config.Box.Ammo.LootTime, false, false, {
                    disableMovement = true,
                    disableCarMovement = true,
                    disableMouse = false,
                    disableCombat = true
                    }, {
                        animDict = 'mini@repair',
                        anim = 'fixing_a_player',
                        flags = 1, 
                    }, {}, {}, function()
                        for i = math.random(2,5), 1, -1 do
                            local item = Config.Box.Ammo.Items[math.random(#Config.Box.Ammo.Items)]
                            local quantity = math.random(Config.Box.Ammo.Quantity.Min, Config.Box.Ammo.Quantity.Max)
                            TriggerServerEvent('pp-weedshoprv2:server:rewardItem', 'item', item, quantity, 'add')
                            ClearPedTasks(ply)
                        end
                        TriggerServerEvent('pp-weedshoprv2:server:event', 'ammo', k)
                    end, function()
                        ClearPedTasks(ply)
                end)
            elseif type == 'weapon' then
                QBCore.Functions.Progressbar('weapon', Lang:t('progressbar.weapons_label'), Config.Box.Weapons.LootTime, false, false, {
                    disableMovement = true,
                    disableCarMovement = true,
                    disableMouse = false,
                    disableCombat = true
                    }, {
                        animDict = 'mini@repair',
                        anim = 'fixing_a_player',
                        flags = 1, 
                    }, {}, {}, function()
                        for i = math.random(2,5), 1, -1 do
                            local item = Config.Box.Weapons.Items[math.random(#Config.Box.Weapons.Items)]
                            local quantity = math.random(Config.Box.Weapons.Quantity.Min, Config.Box.Weapons.Quantity.Max)
                            TriggerServerEvent('pp-weedshoprv2:server:rewardItem', 'item', item, quantity, 'add')
                            ClearPedTasks(ply)
                        end
                        TriggerServerEvent('pp-weedshoprv2:server:event', 'weapon', k)
                    end, function()
                        ClearPedTasks(ply)
                end)
            elseif type == 'consumables' then
                QBCore.Functions.Progressbar('consumables', Lang:t('progressbar.consumables_label'), Config.Box.Consumables.LootTime, false, false, {
                    disableMovement = true,
                    disableCarMovement = true,
                    disableMouse = false,
                    disableCombat = true
                    }, {
                        animDict = 'mini@repair',
                        anim = 'fixing_a_player',
                        flags = 1, 
                    }, {}, {}, function()
                        for i = math.random(2,5), 1, -1 do
                            local item = Config.Box.Consumables.Items[math.random(#Config.Box.Consumables.Items)]
                            local quantity = math.random(Config.Box.Consumables.Quantity.Min, Config.Box.Consumables.Quantity.Max)
                            TriggerServerEvent('pp-weedshoprv2:server:rewardItem', 'item', item, quantity, 'add')
                            ClearPedTasks(ply)
                        end
                        TriggerServerEvent('pp-weedshoprv2:server:event', 'consumables', k)
                    end, function()
                        ClearPedTasks(ply)
                end)
            else
                QBCore.Functions.Notify(Lang:t('error.invalid_box'), 'error', 3500)
            end
        else
            Skillbar.Repeat({
                duration = math.random(700, 1000),
                pos = math.random(10, 30),
                width = math.random(8, 12),
            })
            succeededAttempts = succeededAttempts + 1
        end
    end, function()
        QBCore.Functions.Notify(Lang:t('error.try_again'), 'error', 3500)
    end)
end

function StopHeist()
    if Started then
        Started = false
        carrierParkZone:destroy()
        RemoveBlip(VehicleBlip)
        DeleteVehicle(MissionVehicle)
        for k, v in ipairs(Config.Box.Drugs.Locations) do
            exports['qb-target']:RemoveZone("DrugBox"..k)
        end
        for k, v in ipairs(Config.Box.Ammo.Locations) do
            exports['qb-target']:RemoveZone("AmmoBox"..k)
        end
        for k, v in ipairs(Config.Box.Weapons.Locations) do
            exports['qb-target']:RemoveZone("WeaponsBox"..k)
        end
        for k, v in ipairs(Config.Box.Consumables.Locations) do
            exports['qb-target']:RemoveZone("ConsumablesBox"..k)
        end
    end
end
function isVehicleParkedinCarrier()
    while true do
        local VehicleCoords = GetEntityCoords(MissionVehicle)
        InsideParking = carrierParkZone:isPointInside(VehicleCoords)
    if InsideParking then
        TriggerEvent('pp-weedshoprv2:client:spawnGuards')
        TriggerEvent('pp-weedshoprv2:client:CreateBoxes') -- //FIX
        TriggerEvent('pp-weedshoprv2:client:GetSecretInfo')
        local alert = Config.PoliceAlerts
        if alert == 'default' then
            TriggerServerEvent('police:server:policeAlert', 'Government stuff robbery. Helicopter needed.')
        elseif alert == 'ps-dispatch' then
            exports['ps-dispatch']:YachtHeist()
        end
        VehicleInCarrier = true
        while IsPedInVehicle(PlayerPedId(), MissionVehicle, false) do
            Wait(100)
            if not IsPedInVehicle(PlayerPedId(), MissionVehicle, false) then
               -- SetVehicleAnchor(true)
                break
            end
        end
        QBCore.Functions.Notify(Lang:t('info.company'), 'info', 3500)
        break
    end
    Wait(1000)
   end
end

function SpawnVehicle()
    local ply = PlayerPedId()
    loadModel(Config.Carrier.Vehicle['model'])
    local VehicleHash = GetHashKey(Config.Carrier.Vehicle['model'])
    MissionVehicle = CreateVehicle(VehicleHash, Config.Carrier.Vehicle['coords'], false, false)
    SetBlipVehicle(MissionVehicle)
    SetVehicleFixed(MissionVehicle)
    SetBoatAnchor(MissionVehicle, true)
    SetModelAsNoLongerNeeded(VehicleHash)
    TriggerEvent("vehiclekeys:client:SetOwner", QBCore.Functions.GetPlate(MissionVehicle))
    QBCore.Functions.Notify(Lang:t('info.see_map'), 'success', 5000)
        while not IsPedInVehicle(ply, MissionVehicle, false) do
            Wait(1000)
            print("aaaaa")
            if IsPedInVehicle(ply, MissionVehicle, false) then
                QBCore.Functions.Notify(Lang:t('info.see_map2'), 'success', 3500)
                SetNewWaypoint(Config.Carrier.Vehicle['parking']['coords'])
               -- SetVehicleAnchor(MissionVehicle, false)
                print("bbbbbb")
                isVehicleParkedinCarrier()
                break
            end
        end
end

function StartRobbery()
    if Started then QBCore.Functions.Notify(Lang:t('error.alreadyStarted'), 'error', 3000) return end
    TriggerServerEvent('pp-weedshoprv2:server:SyncRobbery')
    SpawnVehicle()
end